require "defines"

local cnt=0
local guiactive=false
local renamingTelepadId
local targetRemoteId

local function getTelepadId(t)
  return string.format("telepad:%.0fx%.0f",t.position.x,t.position.y)
end

local function getRemoteId(t)
  return string.format("remote:%.0fx%.0f",t.position.x,t.position.y)
end

local function initGlob()
  glob.telepads=glob.telepads or {}
  glob.telepadNames=glob.telepadNames or {}
  glob.telepadIds=glob.telepadIds or {}
  glob.telepadRemotes=glob.telepadRemotes or {}
end

local function pr(...)
  game.player.print(...)
end

game.onevent(defines.events.ontick, function(event)
  if game.tick % 6 == 0 or cnt>0 then
    local d=game.player.selected
    if d and (d.name=="telepad" or d.name=="telepad-remote-target") then
      if d.energy>=8888 then
        local p=game.player.position
        local f=game.findentities({{p.x-1.2,p.y-1.2},{p.x+1.2,p.y+1.2}})
        local s
        if f then
          for i=1,#f do
            if f[i].name:sub(0,7)=="telepad" then
              s=f[i]
              break
            end
          end
        end
        if s and s.energy>=8888 then
          if d.equals(s) then
            if guiactive then
              return
            end
            cnt=cnt+1
            if cnt>=120 then
              initGlob()
              if d.name=="telepad-remote-target" then
                local id=getRemoteId(d)
                local target=glob.telepadRemotes[id] or ""
                game.player.gui.center.add{type="frame",name="remotetargetset"}
                local g=game.player.gui.center.remotetargetset
                g.add{type="label",caption={"remote-target-name"}}
                g.add{type="textfield",name="telepadname"}
                g.telepadname.text=target
                g.add{type="button",caption="Ok",name="remotetaretok"}
                targetRemoteId=id
              else
                local id=getTelepadId(d)
                local name=glob.telepadNames[id]
                if glob.telepads[id]==nil or not glob.telepads[id].valid then
                  name=id
                  glob.telepads[id]=d
                  glob.telepadNames[id]=id
                  glob.telepadIds[id]=id
                 end
                game.player.gui.center.add{type="frame",name="telepadrename"}
                local g=game.player.gui.center.telepadrename
                g.add{type="label",caption={"telepad-name"}}
                g.add{type="textfield",name="telepadname"}
                g.telepadname.text=name
                g.add{type="button",caption="Ok",name="telepadrenameok"}
                renamingTelepadId=id
              end
              cnt=0
              guiactive=true
            end
            return
          else
            local maxWait=120
            if s.name=="telepad-remote-target" then
              cnt=0
              return
            end
            if d.name=="telepad-remote-target" then
              maxWait=300
              local r=d
              local targetName=glob.telepadRemotes and glob.telepadRemotes[getRemoteId(d)]
              if not targetName then
                cnt=0
                return
              end
              if targetName then
                local tid=glob.telepadIds[targetName]
                if tid and glob.telepads[tid] then
                  d=glob.telepads[tid]
                  if not d.valid then
                    glob.telepads[tid]=nil
                    glob.telepadNames[tid]=nil
                    glob.telepadIds[targetName]=nil
                    cnt=0
                    return
                  end
                  if d.energy<8888 or s.equals(d) then
                    cnt=0
                    return
                  end
                  r.energy=r.energy-8888
                else
                  cnt=0
                  return
                end
              end
            end
            cnt=cnt+1
            s.energy=s.energy-8888
            d.energy=d.energy-8888
            if cnt>=maxWait then
              local pos=d.position
              game.player.teleport{x=pos.x,y=pos.y+0.5}
              game.createentity{name="telepad-sfx-dummy",position={s.position.x+1,s.position.y+1}}
            --local sfx=game.findentitiesfiltered{area={{pos.x+0.5,pos.y+0.5},{pos.x+1.5,pos.y+1.5}},name="telepad-sfx-dummy"}
            --sfx[1].die()
              cnt=0
            end
            return
          end
        end
      end
    end
    cnt=0
  end
end)

game.onevent(defines.events.onguiclick,function(e)
  local en=e.element.name
  if en=="telepadrenameok" then
    local g=game.player.gui.center.telepadrename
    local nm=g.telepadname.text
    if #nm==0 then
      return
    end
    if glob.telepadIds[nm] and glob.telepadIds[nm] ~= renamingTelepadId then
      if glob.telepads[glob.telepadIds[nm]].valid then
        glob.telepads[glob.telepadIds[nm]]=nil
      else
        game.showmessagedialog{text={"duplicate-telepad-name"}}
        return
      end
    end
    glob.telepadNames[renamingTelepadId]=nm
    glob.telepadIds[nm]=renamingTelepadId
    g.destroy()
    guiactive=false
  elseif en=="remotetaretok" then
    local g=game.player.gui.center.remotetargetset
    glob.telepadRemotes[targetRemoteId]=g.telepadname.text
    g.destroy()
    guiactive=false
  end
end)
