data:extend{
  {
    type = "pump",
    name = "telepad",
    icon = "__telepad__/graphics/icons/telepad.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness=0.5,mining_time = 1, result = "telepad"},
    max_health = 200,
    render_layer = "decorative",
    corpse = "small-remnants",
    collision_box = {{-0.1,-0.1},{0.1,0.1}},
    selection_box = {{-1, -0.3}, {1, 1.3}},
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      drain = "100KW"
    },
    energy_usage = "500KW",
    pumping_speed = 0,
    fluid_box={
      pipe_connections={},
    },
    animations =
    {
      north={
        filename = "__telepad__/graphics/telepad2.png",
        priority = "low",
        width = 64,
        height = 48,
        frame_count=1,
        shift = {0, 0.5},
        animation_speed=0.5,
      },
      south={
        filename = "__telepad__/graphics/telepad2.png",
        priority = "low",
        width = 64,
        height = 48,
        frame_count=1,
        shift = {0, 0.5},
        animation_speed=0.5,
      },
      west={
        filename = "__telepad__/graphics/telepad2.png",
        priority = "low",
        width = 64,
        height = 48,
        frame_count=1,
        shift = {0, 0.5},
        animation_speed=0.5,
      },
      east={
        filename = "__telepad__/graphics/telepad2.png",
        priority = "low",
        width = 64,
        height = 48,
        frame_count=1,
        shift = {0, 0.5},
        animation_speed=0.5,
      },
    },
    picture_off =
      {
      filename = "__telepad__/graphics/telepad2.png",
      priority = "low",
      width = 64,
      height = 48,
      shift = {0, 0.7}
      },
  },
  {
    type = "pump",
    name = "telepad-remote-target",
    icon = "__telepad__/graphics/icons/target-icon.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness=0.5,mining_time = 1, result = "telepad-remote-target"},
    max_health = 200,
    render_layer = "decorative",
    corpse = "small-remnants",
    collision_box = {{-0.01,-0.01},{0.01,0.01}},
    selection_box = {{-0.5, -0.15}, {0.5, 0.75}},
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      drain = "100KW"
    },
    energy_usage = "500KW",
    pumping_speed = 0,
    fluid_box={
      pipe_connections={},
    },
    animations =
    {
      north={
        filename = "__telepad__/graphics/target.png",
        priority = "low",
        width = 32,
        height = 24,
        frame_count=1,
        animation_speed=1,
        shift = {0, 0.3}
      },
      south={
        filename = "__telepad__/graphics/target.png",
        priority = "low",
        width = 32,
        height = 24,
        frame_count=1,
        animation_speed=1,
        shift = {0, 0.3}
      },
      east={
        filename = "__telepad__/graphics/target.png",
        priority = "low",
        width = 32,
        height = 24,
        frame_count=1,
        animation_speed=1,
        shift = {0, 0.3}
      },
      west={
        filename = "__telepad__/graphics/target.png",
        priority = "low",
        width = 32,
        height = 24,
        frame_count=1,
        animation_speed=1,
        shift = {0, 0.3}
      },
    },
  },
  {
    type = "explosion",
    name = "telepad-sfx-dummy",
    max_health=1,
    flags = {"not-on-map"},
    light = {intensity = 1, size = 20},
    sound = {
      {
        filename = "__telepad__/sounds/teleport.ogg",
        volume = 0.7,
      }
    },
    animations =
    {
      {
        filename = "__telepad__/graphics/empty.png",
        priority = "extra-high",
        width = 1,
        height = 1,
        frame_count = 1,
        animation_speed = 0.5
      },
    },
  },
}
